Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
-  trait MatchCodeGen extends Interface

  Factory methods used by TreeMakers to make the actual trees.

  Factory methods used by TreeMakers to make the actual trees.

  We have two modes in which to emit trees: optimized (the default) and pure (aka "virtualized": match is parametric in its monad).

  Definition Classes
    patmat
- CODE
- CodegenCore
- MatchMonadInterface
- OptimizedCodegen
- PureCodegen
- PureMatchMonadInterface
- TypedSubstitution
- vpmName

t

scala.tools.nsc.transform.patmat.MatchCodeGen

# OptimizedCodegen 

###

#### trait OptimizedCodegen extends CodegenCore with TypedSubstitution with MatchMonadInterface

Source
  MatchCodeGen.scala

Linear Supertypes
MatchCodeGen.TypedSubstitution, CodegenCore, MatchCodeGen.MatchMonadInterface, AnyRef, Any
Known Subclasses
CommonSubconditionElimination, MatchOptimizer, OptimizingMatchTranslator
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. OptimizedCodegen
2. TypedSubstitution
3. CodegenCore
4. MatchMonadInterface
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  class Substitution extends AnyRef
   Definition Classes
     TypedSubstitution
2.  trait AbsCodegen extends AnyRef
   Definition Classes
     CodegenCore
3.  trait Casegen extends AbsCodegen
   Definition Classes
     CodegenCore
4.  abstract class CommonCodegen extends AbsCodegen
   Definition Classes
     CodegenCore

### Abstract Value Members

1.  abstract val typer: (analyzer)#Typer
   Definition Classes
     MatchMonadInterface

### Concrete Value Members

1.  object EmptySubstitution extends Substitution
   Definition Classes
     TypedSubstitution
2.  object Substitution
   Definition Classes
     TypedSubstitution
3.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
4.  final def ##(): Int
   Definition Classes
     AnyRef → Any
5.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from OptimizedCodegen to any2stringadd[OptimizedCodegen] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
6.  def ->[B](y: B): (OptimizedCodegen, B)
   Implicit
     This member is added by an implicit conversion from OptimizedCodegen to ArrowAssoc[OptimizedCodegen] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
7.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
10.  def codegen: AbsCodegen
    Definition Classes
      OptimizedCodegen → CodegenCore
11.  def ensuring(cond: (OptimizedCodegen) ⇒ Boolean, msg: ⇒ Any): OptimizedCodegen
    Implicit
      This member is added by an implicit conversion from OptimizedCodegen to Ensuring[OptimizedCodegen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: (OptimizedCodegen) ⇒ Boolean): OptimizedCodegen
    Implicit
      This member is added by an implicit conversion from OptimizedCodegen to Ensuring[OptimizedCodegen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean, msg: ⇒ Any): OptimizedCodegen
    Implicit
      This member is added by an implicit conversion from OptimizedCodegen to Ensuring[OptimizedCodegen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean): OptimizedCodegen
    Implicit
      This member is added by an implicit conversion from OptimizedCodegen to Ensuring[OptimizedCodegen] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
16.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
17.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
18.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from OptimizedCodegen to StringFormat[OptimizedCodegen] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
19.  def freshName(prefix: String): Global.TermName
    Definition Classes
      CodegenCore
20.  def freshSym(pos: Global.Position, tp: Global.Type = NoType, prefix: String = "x"): Global.TermSymbol
    Definition Classes
      CodegenCore
21.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
22.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
23.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
24.  val matchOwner: Global.Symbol
    Definition Classes
      MatchMonadInterface
25.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
26.  def newSynthCaseLabel(name: String): Global.MethodSymbol
    Definition Classes
      CodegenCore
27.  final def notify(): Unit
    Definition Classes
      AnyRef
28.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
29.  def pureType(tp: Global.Type): Global.Type
    Definition Classes
      MatchMonadInterface
30.  def reportMissingCases(pos: Global.Position, counterExamples: List[String]): Unit
    Definition Classes
      MatchMonadInterface
31.  def reportUnreachable(pos: Global.Position): Unit
    Definition Classes
      MatchMonadInterface
32.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
33.  def toString(): String
    Definition Classes
      AnyRef → Any
34.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
35.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
36.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
37.  def →[B](y: B): (OptimizedCodegen, B)
    Implicit
      This member is added by an implicit conversion from OptimizedCodegen to ArrowAssoc[OptimizedCodegen] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
38.  object optimizedCodegen extends CommonCodegen

### Inherited from MatchCodeGen.TypedSubstitution

### Inherited from CodegenCore

### Inherited from MatchCodeGen.MatchMonadInterface

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from OptimizedCodegen to any2stringadd[OptimizedCodegen]

### Inherited by implicit conversion StringFormat from OptimizedCodegen to StringFormat[OptimizedCodegen]

### Inherited by implicit conversion Ensuring from OptimizedCodegen to Ensuring[OptimizedCodegen]

### Inherited by implicit conversion ArrowAssoc from OptimizedCodegen to ArrowAssoc[OptimizedCodegen]

### Ungrouped